import { InputConsumer } from 'input-ui-ipc-provider';
import { NamedNode, Node, SignaturedDeclaration, SourceFile } from 'ts-simple-ast';
import * as ts from 'typescript';
import { CodeFixOptions } from 'ts-simple-ast-extra';
import { Action, Tool, ToolConfig, ActionConfig } from "typescript-plugins-text-based-user-interaction";
import * as ts_module from 'typescript/lib/tsserverlibrary';
import { SignatureRefactorArgs, SignatureRefactorsCodeFix } from './refactors';
import { TargetInfo } from './util';
export declare abstract class SignatureAbstractCodeFix implements SignatureRefactorsCodeFix {
    protected options: SignatureRefactorArgs;
    protected interactionTool: Tool;
    protected inputConsumer: InputConsumer;
    protected selectedAction?: Action;
    protected targetInfo: TargetInfo | undefined;
    name: string;
    config: any;
    constructor(options: SignatureRefactorArgs);
    abstract getTextUIToolConfig(): ToolConfig;
    abstract apply(arg: CodeFixOptions): void | ts.ApplicableRefactorInfo[];
    abstract printRefactorSuggestionMessage(targetInfo: TargetInfo): string;
    predicate(arg: CodeFixOptions): boolean;
    description(arg: CodeFixOptions): string;
    getCompletionsAtPosition(fileName: string, position: number, options: ts.GetCompletionsAtPositionOptions): ts.CompletionEntry[];
    getTargetInfo(sourceFile: ts.SourceFile, position: number): TargetInfo | undefined;
    protected getSimpleTargetNode(file: SourceFile, position: number, name: string, log: (msg: string) => void): SignaturedDeclaration & NamedNode & Node | undefined;
    getApplicableRefactors(info: ts_module.server.PluginCreateInfo, refactorName: string, refactorActionName: string, fileName: string, positionOrRange: number | ts.TextRange, userPreferences: ts_module.UserPreferences): {
        refactors: ts.ApplicableRefactorInfo[];
        selectedAction?: Action;
    };
    protected applyImpl(arg: CodeFixOptions, fn: (n: Node) => void): void;
    abstract helpComment(): string;
    /** heads up ! this is very generic - you must override it as reorderParams does */
    textUIToolConfigFactory(config: Partial<ActionConfig>): {
        prefix: string;
        log: (msg: string) => void;
        actions: ({
            name: string;
            args: string[];
            commentType: string;
            print: (action: any) => string;
            snippet: (fileName: string, position: number) => string;
            nameExtra: (fileName: string, position: number) => string;
        } & Partial<ActionConfig>)[];
    };
}
