import { ts } from 'ts-simple-ast';
import { CodeFixOptions } from 'ts-simple-ast-extra';
import { ToolConfig } from "typescript-plugins-text-based-user-interaction";
import { SignatureAbstractCodeFix } from '../SignatureAbstractCodeFix';
import { TargetInfo } from '../util';
/**
 * # Description
 *
 *  Allows users to remove parameters from signature/function-like declarations, calls, etc. see README
 *
 * # TODO
 *
 *  * refactor a implementation method wont change its interface signature - super
 *  * constructors not supported
 *  * perhaps is better to offer a GUI multiple select ? !!!
 */
export declare class removeParamsCodeFixImpl extends SignatureAbstractCodeFix {
    name: string;
    config: any;
    remove: number[];
    printRefactorSuggestionMessage(targetInfo: TargetInfo): string;
    getTextUIToolConfig(): ToolConfig;
    getTargetInfo(sourceFile: ts.SourceFile, position: number): TargetInfo | undefined;
    apply(arg: CodeFixOptions): void | ts.ApplicableRefactorInfo[];
    helpComment(): string;
}
